#ifndef ConnectionH

#define ConnectionH
#define MAXCONNECTION 100
#define DATABLOCKSIZE 8192
#include <winsock.h>
#include "flashftp.h"

struct _Connection{
       SOCKET Socket;
       int Index;
       int State;
       int UserID;
       int ServerID;
       int TickCount;//ʱ 
       HANDLE DataThread;
       HANDLE ThisThread;
       char FileName[256];
       char LocalDirectory[1024];
       char CurrentDirectory[1024];
       int RemotePort;
       int DataRemotePort;
       char DataRemoteIP[32];
       SOCKET DataSocket;
       bool PassiveMode;
       char InUsed;// whether it is used, but when it closed, 
       //we'd better not delete it, for the next connection.
};

enum // Token ID's
{
     TOK_USER=0, TOK_PASS, TOK_CWD, TOK_PWD, 
     TOK_PORT, TOK_PASV, TOK_TYPE, TOK_LIST,
     TOK_REST, TOK_CDUP, TOK_RETR, TOK_STOR,
     TOK_SIZE, TOK_DELE, TOK_RMD, TOK_MKD,
     TOK_RNFR, TOK_RNTO, TOK_ABOR, TOK_SYST, TOK_NOOP, 
     TOK_BYE, TOK_QUIT, TOK_ERROR,
};

enum{
     NotLogged=0,
     Logged,
     Listing,
     Downloading,
     Uploading
};

struct _Command{
       int ID;
       char *str;
};
struct _Connection *Connection[MAXCONNECTION];
int ConnectionCount;

int CreateConnection(int SID,SOCKET s);
DWORD WINAPI ConnectionInstanceProc(LPVOID lpParameter);
bool Send(const SOCKET s,const char *str);
bool SendEx(const SOCKET s, unsigned char *sendbuff, const int nBytes);//wait 
int GetUserByName(const char *name);
void Quit(int CID);

#endif
