#ifndef FlashFTP

#define FlashFTP
#define MAXUSER 500
#define MAX_HOSTNAME_LAN 1024
#define MAXDIRECTORYLISTBYTES 81920

typedef short int bool;
#define false 0
#define true -1

/* Define the Accounts of User's Virtual Directory */
struct _Account{
       bool bCreateDirectory;
       bool bDownloadFile;
       bool bUploadFile;
       bool bChangeName;
       bool bDeleteDirectory;
       bool bDeleteFile;
};

/* Define the Virtual Directory */
struct _Directory{
       char Name[256];
       char Local[1024];
       long MaxSize; //Can't be large than this size
    //   char AllowedExts[1024]; //The file type can be allowed. 
       struct _Account Account;
       bool Enabled;
};

/* Define User Informations */
struct _User{
       char UserName[16];
       char PassWord[16];
       struct _Directory *Directory[10]; //
       int DirCount;
       int MaxConnections;
       int OnlineConnections;
       int ServerID;
       int UserGroup;
       bool Enabled;
};


bool FTPOK;
bool InitProgram();

struct _User *User[MAXUSER];
int UserCount;
int UserGroupCount;
unsigned char LocalIP[4];// Local ip for pasv used;
char LocalHostName[MAX_HOSTNAME_LAN];// Local ip for pasv used;
//bool WaitingNumber;//Correct a bug
#endif
