#include "DataConnection.h"
#include "winsock.h"
#include "string.h"

/********************************************************************/
/*																	*/
/* Function name : ConnectDataSocket								*/
/* Description   : ͻ˵Socket				            */
/*																	*/
/********************************************************************/
bool ConnectDataSocket(struct _Connection *c)
{
     if (!c->PassiveMode)
     {
         SOCKADDR_IN m_sockaddr;
         memset( &m_sockaddr,0, sizeof( m_sockaddr ) );
         //closesocket(c->DataSocket);
         if ((c->DataSocket = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP )) == INVALID_SOCKET )
         {
             return false;
         }
         m_sockaddr.sin_family = AF_INET;
         m_sockaddr.sin_addr.s_addr = INADDR_ANY;
         m_sockaddr.sin_port = htons( 0 );
         if ( bind( c->DataSocket, (SOCKADDR*)&m_sockaddr, sizeof( m_sockaddr ) ) == SOCKET_ERROR )
         {
             return false;
         }
         memset( &m_sockaddr,0, sizeof( m_sockaddr ) );
         m_sockaddr.sin_family = AF_INET;
         m_sockaddr.sin_addr.s_addr = inet_addr(c->DataRemoteIP );
         m_sockaddr.sin_port = htons( c->DataRemotePort );
         //printf("%s,%d\n",c->DataRemoteIP,c->DataRemotePort);
         if ( connect( c->DataSocket, (SOCKADDR*)&m_sockaddr, sizeof( m_sockaddr ) ) == SOCKET_ERROR )
         {
             return false;
         }
     }else{
         SOCKET Accept;
         SOCKADDR_IN m_rsockaddr;
         int Len=sizeof( m_rsockaddr );
         memset( &m_rsockaddr, 0, sizeof( m_rsockaddr ) );
         if( ( Accept = accept( c->DataSocket , (SOCKADDR*)&m_rsockaddr, &Len ) ) == INVALID_SOCKET )
         {
             //printf("Socket Accept Error.");
             return false;
         }
         closesocket( c->DataSocket );
         c->DataSocket = Accept;
     }
     return true;
}

