/*
  Name: Flash
  Copyright: Huang's workgroup
  Author: Huang Guan
  E-Mail: Huang_2008@msn.com
  Date: 25-01-06 23:31
  Description: Not finished yet.
*/


#include <windows.h>
#include <stdio.h>

#include "Connection.h"
#include "FlashFTP.h"
#include "Server.h"
#include "Manager.h"


void DoTestInit();
bool LoadConfig(char *File);
int GetData(FILE *fp,char *buf);
int fgetline(FILE *fp, char *buf,int maxlen);
char* rtrimstr(char *buf);
char* ltrimstr(char *buf);
/********************************************************************/
/*																	*/
/* Function name : Main                     						*/
/* Description   : ں                      				    */
/*																	*/
/********************************************************************/
int main()
{
    char c[256],v[256];
    //printf("Program starting ...\n");
    if(!InitProgram())
                      return 0;
    //printf("Program is Inited ...\n");
    if(!InitServer()){        
        printf("Failed to create thread ...\n");
        system("PAUSE");
        return 0;
    }
    //printf("Server is Inited ...\n");
    printf("Press \"close\" Key to Quit ...\n");
    while(FTPOK){
               printf("FlashFTP>");
	           scanf("%s",c);
	           if(strcmp(c,"close")==0)FTPOK=false;
	           if(strcmp(c,"view")==0){
                   scanf("%s",v);
                   int i;
                   if(strcmp(v,"conn")==0){
                       printf("ConnectionCount:%d\n",ConnectionCount);
                       for(i=0;i<ConnectionCount;i++)
                       {
                           printf("Connection[%d]:\n",i);
                           printf("\tState:%d\n",Connection[i]->State);
                           printf("\tUserID:%d\n",Connection[i]->UserID);
                           printf("\tServerID:%d\n",Connection[i]->ServerID);
                           printf("\tTickCount:%d\n",Connection[i]->TickCount);
                           printf("\tThisThread:%d\n",Connection[i]->ThisThread);
                           printf("\tLocalDirectory:%s\n",Connection[i]->LocalDirectory);
                           printf("\tCurrentDirectory:%s\n",Connection[i]->CurrentDirectory);
                           printf("\tSocket:%d\n",Connection[i]->Socket);
                           printf("\tDataSocket:%d\n",Connection[i]->DataSocket);
                           printf("\tPassiveMode:%d\n",Connection[i]->PassiveMode);
                           printf("\tInUsed:%d\n",Connection[i]->InUsed);
                           
                       }
                   } 
                   if(strcmp(v,"server")==0){
                       printf("ServerCount:%d\n",ServerCount);
                       for(i=0;i<ServerCount;i++)
                       {
                           printf("Server[%d]:\n",i);
                           printf("\tState:%d\n",Server[i]->State);
                           printf("\tName:%s\n",Server[i]->Name);
                           printf("\tIP::%s\n",Server[i]->IP);
                           printf("\tPort:%d\n",Server[i]->Port);
                           printf("\tMaxConnections:%d\n",Server[i]->MaxConnections);
                           printf("\tOnlineConnections:%d\n",Server[i]->OnlineConnections);
                           printf("\tWelcomeText:%s\n",Server[i]->WelcomeText);
                           printf("\tGoodByeText:%s\n",Server[i]->GoodByeText);
                           printf("\tThread:%d\n",Server[i]->Thread);
                           printf("\tSocket:%d\n",Server[i]->Socket);
                           
                       }
                   }
                   if(strcmp(v,"user")==0){
                       printf("UserCount:%d\n",UserCount);
                       for(i=0;i<UserCount;i++)
                       {
                           printf("User[%d]:\n",i);
                           printf("\tName:%s\n",User[i]->UserName);
                           printf("\tPassWord:%s\n",User[i]->PassWord);
                           printf("\tServerID:%d\n",User[i]->ServerID);
                           printf("\tMaxConnections:%d\n",User[i]->MaxConnections);
                           printf("\tOnlineConnections:%d\n",User[i]->OnlineConnections);
                           printf("\tUserGroup:%d\n",User[i]->UserGroup);
                           printf("\tEnabled:%d\n",User[i]->Enabled);
                           
                       }
                   }                                                                                         
               }
               if(strcmp(c,"clear")==0){
                   int i;
                   for(i=0;i<ConnectionCount;i++)
                   if(Connection[i]->InUsed)Quit(i);
               }
	           //printf("Server[0].OnlineConnections:%d\n",Server[0]->OnlineConnections);
    }
    CloseServer();
    CloseHandle(ManagerThread);
    system("PAUSE");
    return 0;
}



/********************************************************************/
/*																	*/
/* Function name : InitProgram         								*/
/* Description   : Դڽгʼݳʼ				        */
/*																	*/
/********************************************************************/
bool InitProgram()
{
     //WriteTitle("Flash FTP Server");
     ConnectionCount=0;
     ServerCount=0;
     UserCount=0;
     FTPOK=true;
     //Create Manager Thread
     DWORD ThreadID;
     if((ManagerThread = CreateThread(NULL, 0, ManagerInstanceProc,
    			NULL, 0, &ThreadID)) == NULL)
     {
         return false;
     }
     
     //DoTestInit(); 
     if(! LoadConfig("./config"))
     {
          printf("Load Data false...");
          return false;
     }
     return true;
}


/********************************************************************/
/*																	*/
/* Function name : GetUserByName       								*/
/* Description   : ֻͨûID				                */
/*																	*/
/********************************************************************/
int GetUserByName(const char *name)
{
    int i;
    for (i=0; i<UserCount;i++)
        if(strcmp(name,User[i]->UserName)==0)
        {
             return i;
        }
    return -1;
}

/********************************************************************/
/*																	*/
/* Function name : DoTestInit          								*/
/* Description   :                        			            */
/*																	*/
/********************************************************************/
void DoTestInit()
{
     LoadConfig("./config");
     ServerCount=1;
     Server[0]=malloc(sizeof(Server[0]));
     sprintf(Server[0]->GoodByeText,"Bye!");
     sprintf(Server[0]->WelcomeText,"Welcome!");
     strcpy(Server[0]->Name,"Test");
     Server[0]->MaxConnections=10;
     Server[0]->Port=21;
     Server[0]->State=Stopped;
     //Server[0]->UserCount=1;
     Server[0]->Index=0;
     UserCount=1;
     User[0]=malloc(sizeof(struct _User));
     User[0]->DirCount=1;
     User[0]->Directory[0]=malloc(sizeof(struct _Directory));
     User[0]->Directory[0]->Enabled=true;
     User[0]->Directory[0]->MaxSize=0;
     strcpy(User[0]->Directory[0]->Name,"Default");
     strcpy(User[0]->Directory[0]->Local,"E:/");
     strcpy(User[0]->UserName,"anonymous");
     User[0]->MaxConnections=2;
     strcpy(User[0]->PassWord,"");
     User[0]->ServerID=0;
     User[0]->UserGroup=0;
}

char* ltrimstr(char *buf)
{
    int len=strlen(buf),i;
    if(len<1)return buf;
    while(buf[0]==' '||buf[0]=='\n')
    {
        if(len<1)return buf;
        for(i=0;i<len-1;i++)
        {
           buf[i]=buf[i+1];
        }
        buf[i]='\0';
        len--;
    }
    return buf;  
}
char* rtrimstr(char *buf)
{
    int len=strlen(buf);
    if(len<1)return buf;
    while(buf[len-1]==' '||buf[len-1]=='\r')
    {
        if(len<1)return buf;
        buf[len-1]='\0';
        len--;
    }
    return buf;  
}
int fgetline(FILE *fp, char *buf,int maxlen)
{
    int i;
    memset(buf,0,maxlen);
    if(fgets(buf, maxlen, fp) == NULL) 
    { 
      i = strlen(buf); 
      if(feof(fp) != 0) 
      { 
        if(i == 0) return -1;                 /* EOF */ 
      } 
      else return -2;                         /* error */ 
    } 
    i = strlen(buf); 
    if(i > 0 && buf[i-1] == '\n') 
    buf[--i] = '\0'; 
    return i; 
}

int GetData(FILE *fp,char *buf)
{
     bool GetOK=false;
     int len;
     while(eof(fp)!=0)
     {
         fgetline(fp, buf ,256);
         len=strlen(ltrimstr(rtrimstr(buf)));
         if(len<1)continue;
         if(buf[0]=='/')continue;
         if(strcmp(buf,"NULL")==0){
            strcpy(buf,"");
            len=0;
         }
         return len;
     }
}
/********************************************************************/
/*																	*/
/* Function name : LoadConfig          								*/
/* Description   :                        			            */
/*																	*/
/********************************************************************/
bool LoadConfig(char *File)
{
     char txt[256];
     int n,i,j,ID;
     FILE *fp=fopen(File,"r");
     if(fp==NULL)return false;
     n=GetData(fp,txt);
     //Server Count
     ServerCount=atoi(txt);
     for(i=0;i<ServerCount;i++)
     {
         n=GetData(fp,txt);
         ID=atoi(txt);
         Server[i]=malloc(sizeof(struct _Server));
         n=GetData(fp,txt);
         strcpy(Server[i]->Name,txt);
         n=GetData(fp,txt);
         Server[i]->State=atoi(txt);
         n=GetData(fp,txt);
         strcpy(Server[i]->IP,txt);
         n=GetData(fp,txt);
         Server[i]->Port=atoi(txt);
         n=GetData(fp,txt);
         Server[i]->MaxConnections=atoi(txt);
         n=GetData(fp,txt);
         strcpy(Server[i]->WelcomeText,txt);
         n=GetData(fp,txt);
         strcpy(Server[i]->GoodByeText,txt);
         Server[i]->Index=i;
     }
     n=GetData(fp,txt);
     UserGroupCount=atoi(txt);
     n=GetData(fp,txt);
     UserCount=atoi(txt);
     for(i=0;i<UserCount;i++)
     {
         User[i]=malloc(sizeof(struct _User));
         n=GetData(fp,txt);
         strcpy(User[i]->UserName,txt);
         n=GetData(fp,txt);
         strcpy(User[i]->PassWord,txt);
         n=GetData(fp,txt);
         User[i]->ServerID=atoi(txt);
         n=GetData(fp,txt);
         User[i]->Enabled=atoi(txt);
         n=GetData(fp,txt);
         // 
         if(n==0)
         {
             n=GetData(fp,txt);
             User[i]->MaxConnections=atoi(txt);
             n=GetData(fp,txt);
             User[i]->DirCount=atoi(txt);
             for(j=0;j<User[i]->DirCount;j++)
             {
                 User[i]->Directory[j]=malloc(sizeof(struct _Directory));
                 n=GetData(fp,txt);
                 strcpy(User[i]->Directory[j]->Name,txt);
                 n=GetData(fp,txt);
                 strcpy(User[i]->Directory[j]->Local,txt);
                 n=GetData(fp,txt);
                 User[i]->Directory[j]->MaxSize,atoi(txt);
                 n=GetData(fp,txt);
                 User[i]->Directory[j]->Account,atoi(txt);
             }
         }
     }
     return true;
}
     
