#include "Server.h"
#include "Connection.h"

/********************************************************************/
/*																	*/
/* Function name : CloseServer         								*/
/* Description   : رһ				                    */
/*																	*/
/********************************************************************/
void CloseServer()
{
     int i,j;
     WSACleanup();
     for(i=0;i<ServerCount;i++)
     {
         CloseHandle(Server[i]->Thread);
         free(Server[i]);
     }
     for(i=0;i<ConnectionCount;i++)
     {
        free(Connection[i]);
     }
     for(i=0;i<UserCount;i++)
     {
        for(j=0;j<User[i]->DirCount;j++)
            free(User[i]->Directory[j]);
        free(User[i]);
     }
}


/********************************************************************/
/*																	*/
/* Function name : InitServer          								*/
/* Description   : ʼ			                        */
/*																	*/
/********************************************************************/
bool InitServer()
{
     WSADATA wsaD; 
     int result = WSAStartup((WORD)(1<<8|1), &wsaD); //ʼWinSocket̬ӿ
     if( result != 0 ) // ʼʧܣ
     {
         return false;
     }
     //printf("WSA is Startupped ...\n");
     int SID;
     for(SID=0;SID<ServerCount;SID++)
     {
         if(Server[SID]->State!=Running)continue;
         Server[SID]->OnlineConnections=0;
         Server[SID]->State=Stopped;
         //Create Listen socket Thread
         DWORD ThreadID;
         if((Server[SID]->Thread = CreateThread(NULL, 0, ListenInstanceProc,
    			&Server[SID]->Index, 0, &ThreadID)) == NULL)
         {
             printf("Create Server Thread failed.\n");
                                     break;
         }
     }
     //CloseHandle(ListenThread);
     //printf("Create Thread:%d\n",Server[SID]->Thread);
     
     //get Local IP
     //ȡIPַ
    gethostname(LocalHostName, MAX_HOSTNAME_LAN);
    printf("Host Name: %s\n",LocalHostName);
    struct hostent FAR * pHostent; //ע䣬ȶpHostentһ
    pHostent = (struct hostent * )malloc(sizeof(struct hostent)); 
    pHostent = gethostbyname(LocalHostName); 
    memcpy(LocalIP,pHostent->h_addr_list[0], pHostent->h_length);
    printf("Local IP: %d.%d.%d.%d\n",LocalIP[0],LocalIP[1],LocalIP[2],LocalIP[3]);
    free(pHostent); 
    
     return true;
}

/********************************************************************/
/*																	*/
/* Function name : ListenInstanceProc      							*/
/* Description   : ߳			                        */
/*																	*/
/********************************************************************/
DWORD WINAPI ListenInstanceProc(LPVOID lpParameter)
{
      // This is a listen socket
      int *index=lpParameter;
      int SID=*index;
      SOCKET Accept;
Setup:
      if ( (Server[SID]->Socket = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP )) == INVALID_SOCKET )
      {
         printf("Thread Closed.Create socket error\n");
         return false;
      }
      //printf("Server %d Created Socket %d.\n",SID,Server[SID]->Socket);
      //Bind It
      Server[SID]->LocalAddress.sin_family = AF_INET;
      Server[SID]->LocalAddress.sin_addr.s_addr = INADDR_ANY;
      Server[SID]->LocalAddress.sin_port = htons( Server[0]->Port);
      if ( bind( Server[SID]->Socket, (SOCKADDR*)&Server[SID]->LocalAddress, sizeof( Server[SID]->LocalAddress ) ) == SOCKET_ERROR )
      {
         printf("Thread Closed. Bind socket error\n");
         return false;
      }
      //printf("Bind Socket.\n");
      //Let it Listen
      if( listen( Server[SID]->Socket, 5 ) == SOCKET_ERROR )
      {
         printf("Thread Closed.listen socket error\n");
         return false;
      }
      //printf("Listend Socket.\n");
      //char strData[]="hello world.\0";
      //int iLen=strlen(strData);
      while(FTPOK){
              if ((Accept = accept(Server[SID]->Socket, NULL, NULL)) != INVALID_SOCKET)
              {		
                 //printf("Socket %d is Connected.\n",Accept);
                  if (Server[SID]->OnlineConnections<Server[SID]->MaxConnections)
                         CreateConnection(SID,Accept);
                  else{
                         Send(Accept,"502 Too many users on this server.\n");
                         shutdown(Accept,0);
                         closesocket(Accept);
                  }  
                 //Sleep(100);
                 //printf("\"%s\" is Sent.\n",strData);
                 //shutdown(Accept,0);
                 //printf("Socket %d is Closed.\n",Accept);
              }else{
                  if(!FTPOK)return;
                  closesocket(Server[SID]->Socket);
                  printf("%d Server Socket %d error. Restart it.\n",SID,Server[SID]->Socket);
                  goto Setup;;
              }
          //ExitThread(0)
          //return false;
      }
}
